CREATE DATABASE esempio;
create role esempio_user with password 'esempio_user_password' login;
\c esempio;
CREATE TABLE Libro (
LibroID serial NOT NULL,
Titolo VARCHAR(40) NOT NULL,
URL VARCHAR(40),
Abstract TEXT,
LastModified TIMESTAMP,
CONSTRAINT LibroID PRIMARY KEY (LibroID)
);
CREATE TABLE Autori (
AutoreID serial NOT NULL,
Nome VARCHAR(40) NOT NULL,
Cognome VARCHAR(40) NOT NULL,
Indirizzo VARCHAR(40),
Telefono VARCHAR(40),
Email VARCHAR(40),
UserID VARCHAR(40),
Password VARCHAR(40),
LastModified TIMESTAMP,
PRIMARY KEY (AutoreID)
);
CREATE TABLE Autore_Libro (
Autore_Libro_ID serial NOT NULL,
LibroID INTEGER NOT NULL,
AutoreID INTEGER NOT NULL,
LastModified TIMESTAMP,
PRIMARY KEY (Autore_Libro_ID)
);
ALTER TABLE Autore_Libro
ADD FOREIGN KEY (LibroID) REFERENCES Libro (LibroID);
ALTER TABLE Autore_Libro
ADD FOREIGN KEY (AutoreID) REFERENCES Autori (AutoreID);
grant select on libro to esempio_user;
grant insert on libro to esempio_user;
grant update on libro to esempio_user;
grant delete on libro to esempio_user;
grant select on autori to esempio_user;
grant insert on autori to esempio_user;
grant update on autori to esempio_user;
grant delete on autori to esempio_user;
grant select on autore_libro to esempio_user;
grant insert on autore_libro to esempio_user;
grant update on autore_libro to esempio_user;
grant delete on autore_libro to esempio_user;

grant select on libro_libroid_seq to esempio_user;
grant usage on libro_libroid_seq to esempio_user;
grant update on libro_libroid_seq to esempio_user;

grant select on autori_autoreid_seq to esempio_user;
grant usage on autori_autoreid_seq to esempio_user;
grant update on autori_autoreid_seq to esempio_user;

grant select on autore_libro_autore_libro_id_seq to esempio_user;
grant usage on autore_libro_autore_libro_id_seq to esempio_user;
grant update on autore_libro_autore_libro_id_seq to esempio_user;

CREATE DATABASE animalsurvey;
\c animalsurvey;
create table surveyresults (
id int NOT NULL ,
surveyoption varchar (20) NOT NULL ,
votes int NOT NULL ,
constraint surveyresults_id primary key (id)
);
insert into surveyresults (id,surveyoption,votes) values (1,'Dog', 0);
insert into surveyresults (id,surveyoption,votes) values (2,'Cat', 0);
insert into surveyresults (id,surveyoption,votes) values (3,'Bird', 0);
insert into surveyresults (id,surveyoption,votes) values (4,'Snake', 0);
insert into surveyresults (id,surveyoption,votes) values (5,'None', 0);
grant select on surveyresults to esempio_user;
grant insert on surveyresults to esempio_user;
grant update on surveyresults to esempio_user;
grant delete on surveyresults to esempio_user;
